
/*  A Bison parser, made from parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ID	258
#define	STRING	259
#define	INT	260
#define	FLOAT	261
#define	SCRIPT	262
#define	DEF	263
#define	EXTERNPROTO	264
#define	FALSE_TOK	265
#define	IS	266
#define	NULL_TOK	267
#define	PROTO	268
#define	ROUTE	269
#define	TO	270
#define	TRUE_TOK	271
#define	USE	272
#define	EVENT_IN	273
#define	EVENT_OUT	274
#define	EXPOSED_FIELD	275
#define	FIELD	276

#line 21 "parser.y"

#include <stdio.h>
#include <stdlib.h>
#include "config.h"

#ifdef _WIN32
/* Ugly hack: FLOAT and INT are typedef'ed in gl/gl.h for _WIN32.
   We preserve the parser's value and hope the best for GL. */
#define SAVED_FLOAT FLOAT
#define SAVED_INT INT
#undef FLOAT
#undef INT
/* yet another ugly hack: redefine alloca to malloc */
#define alloca malloc
#endif

#include "stdafx.h"

#ifdef _WIN32
#define FLOAT SAVED_FLOAT
#undef SAVED_FLOAT
#define INT SAVED_INT
#undef SAVED_INT
#endif

#include "parser.h"
#include "Scene.h"
#include "Element.h"
#include "EventIn.h"
#include "EventOut.h"
#include "ExposedField.h"
#include "Field.h"
#include "FieldValue.h"

#include "SFMFTypes.h"

#include "Node.h"
#include "NodeScript.h"
#include "Proto.h"

#include "Stack.h"

extern void stopproto(void);

#define SYMB(id) (scene->getSymbol(id))

Scene *scene;
#ifdef HAVE_LIBZ 
 gzFile inputFile;
#else
 FILE *inputFile;
#endif

int lineno = 1;

static Stack<Node *> nodeStack;
static Stack<Proto *> protoStack;
static int     defName = -1;
static int     currentType;

static void    route(const MyString &srcNode, const MyString &srcField,
                     const MyString &dstNode, const MyString &dstField);
static Node   *newNode(const MyString &nodeType);

static int     checkField(Node *node, const MyString &fieldName);
static void    setField(Node *node, int index, FieldValue *value);
static void    isField(Node *node, const MyString &fieldName, const MyString &isName);
static FieldValue *intsToType(IntArray *floats, int type);
static FieldValue *floatsToType(FloatArray *floats, int type);
static FieldValue *stringToType(const char* string, int type);
static FloatArray *intsToFloats(IntArray *ints);
static FieldValue *emptyMF(int type);
static FieldValue *emptyMFNodeOrNULL(int type);
static FieldValue *SillyDefaultValue(int type);
static MyString uniqName(const MyString name);
static MyString checkName(const MyString name);
static void     repairURL(Node* node);


class nameTranslation {
public:
    MyString oldName;
    MyString newName;
    nameTranslation(MyString newN,MyString oldN)
       {newName=newN;oldName=oldN;}
};

Array<nameTranslation*> NameTranslation;

#line 111 "parser.y"
typedef union {
    int			 int32;
    int			 id;
    Node		*node;
    NodeList		*nodeList;
    Element		*element;
    FieldValue		*value;
    float		 sffloat;
    StringArray		*stringArray;
    IntArray		*intArray;
    FloatArray		*floatArray;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		153
#define	YYFLAG		-32768
#define	YYNTBASE	27

#define YYTRANSLATE(x) ((unsigned)(x) <= 276 ? yytranslate[x] : 67)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    26,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    22,     2,    23,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    24,     2,    25,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     8,    10,    12,    14,    16,    18,    19,
    24,    27,    29,    31,    34,    36,    37,    47,    51,    53,
    56,    58,    62,    66,    67,    73,    75,    76,    82,    83,
    91,    94,    96,   100,   104,   108,   112,   121,   123,   124,
   125,   131,   132,   138,   141,   143,   146,   148,   150,   152,
   158,   164,   167,   171,   173,   175,   177,   179,   181,   183,
   185,   187,   191,   193,   195,   199,   201,   203,   207,   211,
   214,   217,   219,   221,   224,   226,   229,   232,   235,   237,
   239,   243,   245,   248,   250
};

static const short yyrhs[] = {    28,
     0,     1,    48,     0,    28,    29,     0,    48,     0,    30,
     0,    32,     0,    46,     0,    49,     0,     0,     8,    57,
    31,    49,     0,    17,    57,     0,    34,     0,    42,     0,
    33,    32,     0,    48,     0,     0,    13,    58,    35,    22,
    37,    23,    24,    36,    25,     0,    33,    30,    28,     0,
    48,     0,    37,    40,     0,    48,     0,    18,    59,     3,
     0,    19,    59,     3,     0,     0,    21,    59,    39,     3,
    60,     0,    38,     0,     0,    20,    59,    41,     3,    60,
     0,     0,     9,    58,    43,    22,    44,    23,    47,     0,
    44,    45,     0,    48,     0,    18,    59,     3,     0,    19,
    59,     3,     0,    21,    59,     3,     0,    20,    59,     3,
     0,    14,    57,    26,     3,    15,    57,    26,     3,     0,
    64,     0,     0,     0,    58,    24,    50,    52,    25,     0,
     0,     7,    24,    51,    53,    25,     0,    52,    55,     0,
    48,     0,    53,    54,     0,    48,     0,    55,     0,    38,
     0,    18,    59,     3,    11,     3,     0,    19,    59,     3,
    11,     3,     0,    56,    60,     0,     3,    11,     3,     0,
    46,     0,    32,     0,     3,     0,     3,     0,     3,     0,
     3,     0,    61,     0,     4,     0,    22,    65,    23,     0,
    30,     0,    12,     0,    22,    66,    23,     0,    62,     0,
    63,     0,    22,    62,    23,     0,    22,    63,    23,     0,
    22,    23,     0,    11,     3,     0,    16,     0,    10,     0,
    62,     5,     0,     5,     0,    63,     6,     0,    63,     5,
     0,    62,     6,     0,     6,     0,     4,     0,    22,    65,
    23,     0,     4,     0,    65,     4,     0,    30,     0,    66,
    30,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   143,   145,   147,   149,   151,   153,   154,   156,   158,   158,
   159,   161,   163,   165,   167,   169,   182,   188,   191,   193,
   199,   201,   203,   204,   204,   207,   209,   209,   212,   226,
   232,   238,   240,   242,   243,   247,   252,   259,   262,   264,
   271,   272,   278,   280,   282,   284,   306,   308,   310,   311,
   312,   314,   317,   319,   320,   322,   326,   329,   332,   336,
   338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
   348,   351,   353,   355,   357,   359,   361,   362,   363,   365,
   367,   369,   372,   374,   377
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ID","STRING",
"INT","FLOAT","SCRIPT","DEF","EXTERNPROTO","FALSE_TOK","IS","NULL_TOK","PROTO",
"ROUTE","TO","TRUE_TOK","USE","EVENT_IN","EVENT_OUT","EXPOSED_FIELD","FIELD",
"'['","']'","'{'","'}'","'.'","vrmlScene","statements","statement","nodeStatement",
"@1","protoStatement","protoStatements","proto","@2","protoBody","interfaceDeclarations",
"restrictedInterfaceDeclaration","@3","interfaceDeclaration","@4","externproto",
"@5","externInterfaceDeclarations","externInterfaceDeclaration","routeStatement",
"URLList","empty","node","@6","@7","nodeBody","scriptBody","scriptBodyElement",
"nodeBodyElement","fieldName","nodeName","nodeType","fieldType","fieldValue",
"sfboolValue","ints","floats","mfstringValue","strings","nodeStatements", NULL
};
#endif

static const short yyr1[] = {     0,
    27,    27,    28,    28,    29,    29,    29,    30,    31,    30,
    30,    32,    32,    33,    33,    35,    34,    36,    36,    37,
    37,    38,    38,    39,    38,    40,    41,    40,    43,    42,
    44,    44,    45,    45,    45,    45,    46,    47,    48,    50,
    49,    51,    49,    52,    52,    53,    53,    54,    54,    54,
    54,    55,    55,    55,    55,    56,    57,    58,    59,    60,
    60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
    60,    61,    61,    62,    62,    63,    63,    63,    63,    64,
    64,    65,    65,    66,    66
};

static const short yyr2[] = {     0,
     1,     2,     2,     1,     1,     1,     1,     1,     0,     4,
     2,     1,     1,     2,     1,     0,     9,     3,     1,     2,
     1,     3,     3,     0,     5,     1,     0,     5,     0,     7,
     2,     1,     3,     3,     3,     3,     8,     1,     0,     0,
     5,     0,     5,     2,     1,     2,     1,     1,     1,     5,
     5,     2,     3,     1,     1,     1,     1,     1,     1,     1,
     1,     3,     1,     1,     3,     1,     1,     3,     3,     2,
     2,     1,     1,     2,     1,     2,     2,     2,     1,     1,
     3,     1,     2,     1,     2
};

static const short yydefact[] = {     0,
    39,     1,     4,     2,    58,     0,     0,     0,     0,     0,
     0,     3,     5,     6,    12,    13,     7,     8,     0,    42,
    57,     9,    29,    16,     0,    11,    40,    39,     0,     0,
     0,     0,    39,    47,     0,    10,    39,    39,     0,    45,
     0,    56,     0,     0,     0,    43,    55,    49,    54,    46,
    48,     0,     0,    32,     0,    21,     0,    41,    44,     0,
    59,     0,     0,    24,    61,    75,    79,    73,     0,    64,
    72,     0,    63,    52,    60,    66,    67,     0,     0,     0,
     0,     0,    31,     0,     0,     0,     0,    26,    20,     0,
    53,    22,    23,     0,    71,    82,    70,    84,     0,     0,
     0,     0,    74,    78,    77,    76,     0,     0,     0,     0,
    80,     0,    30,    38,     0,     0,    27,    39,     0,     0,
     0,     0,    68,    69,    83,    62,    65,    85,    33,    34,
    36,    35,     0,    22,    23,     0,     0,     0,    15,    37,
    50,    51,    25,    81,     0,    39,    14,    17,    28,    18,
     0,     0,     0
};

static const short yydefgoto[] = {   151,
     2,    12,    73,    29,    14,   137,    15,    31,   138,    55,
    48,    94,    89,   136,    16,    30,    53,    83,    17,   113,
     3,    18,    33,    28,    41,    35,    50,    51,    52,    22,
    19,    62,    74,    75,    76,    77,   114,   101,   102
};

static const short yypact[] = {    89,
-32768,   102,-32768,-32768,-32768,   -14,    18,    40,    40,    18,
    18,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    33,-32768,
-32768,-32768,-32768,-32768,    36,-32768,-32768,-32768,    56,    65,
    66,    90,-32768,-32768,     6,-32768,-32768,-32768,    79,-32768,
     9,    84,    96,    96,    96,-32768,-32768,-32768,-32768,-32768,
-32768,    69,   118,-32768,   124,-32768,    18,-32768,-32768,    98,
-32768,   104,   105,-32768,-32768,-32768,-32768,-32768,   109,-32768,
-32768,    48,-32768,-32768,-32768,     8,    63,    96,    96,    96,
    96,     7,-32768,    96,    96,    96,   100,-32768,-32768,    87,
-32768,   103,   115,   117,-32768,-32768,-32768,-32768,    55,    61,
    12,    41,-32768,-32768,-32768,-32768,   122,   125,   126,   127,
-32768,   128,-32768,-32768,   130,   131,-32768,-32768,   137,   143,
   146,    69,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    13,-32768,-32768,   147,   114,   129,   132,-32768,
-32768,-32768,-32768,-32768,    69,-32768,-32768,-32768,-32768,   102,
   151,   152,-32768
};

static const short yypgoto[] = {-32768,
    10,-32768,    -2,-32768,   -33,-32768,-32768,-32768,-32768,-32768,
   106,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -9,-32768,
     0,   133,-32768,-32768,-32768,-32768,-32768,   112,-32768,    -7,
    74,   -39,  -115,-32768,    83,    86,-32768,    47,-32768
};


#define	YYLAST		162


static const short yytable[] = {    13,
     4,    47,    25,    26,    63,    64,   143,    47,    42,    20,
   111,    42,   103,   104,     8,   125,   125,     8,     9,    10,
    21,     9,    10,    43,    44,    49,    45,    34,   112,   149,
    46,    49,    40,    58,   126,   144,    54,    56,   107,   108,
   109,   110,     5,     5,   115,   116,   117,     6,     7,    90,
     5,    96,    66,    67,     6,     7,    27,    11,     5,   103,
   104,    32,     6,   127,    11,   105,   106,   105,   106,    98,
    97,     5,    65,    66,    67,     6,     7,   123,    68,    69,
    70,    23,    24,   124,    71,    11,    37,    38,   -39,     1,
    72,   -39,    39,    57,    60,   -39,   -39,   -39,    61,   128,
    91,   -39,   -39,   147,     5,   -39,    92,    93,     6,     7,
     8,    95,   119,   120,     9,    10,     5,   139,    11,   122,
     6,     7,     8,   118,   129,   121,     9,   130,   131,   132,
    11,    96,   134,   135,   146,    78,    79,    80,    81,   140,
    82,    84,    85,    86,    45,   141,    87,    13,   142,   145,
   152,   153,    59,   148,    99,   150,   -19,   100,   133,     0,
    88,    36
};

static const short yycheck[] = {     2,
     1,    35,    10,    11,    44,    45,   122,    41,     3,    24,
     4,     3,     5,     6,     9,     4,     4,     9,    13,    14,
     3,    13,    14,    18,    19,    35,    21,    28,    22,   145,
    25,    41,    33,    25,    23,    23,    37,    38,    78,    79,
    80,    81,     3,     3,    84,    85,    86,     7,     8,    57,
     3,     4,     5,     6,     7,     8,    24,    17,     3,     5,
     6,    26,     7,    23,    17,     5,     6,     5,     6,    72,
    23,     3,     4,     5,     6,     7,     8,    23,    10,    11,
    12,     8,     9,    23,    16,    17,    22,    22,     0,     1,
    22,     3,     3,    15,    11,     7,     8,     9,     3,   102,
     3,    13,    14,   137,     3,    17,     3,     3,     7,     8,
     9,     3,    26,    11,    13,    14,     3,   118,    17,     3,
     7,     8,     9,    24,     3,    11,    13,     3,     3,     3,
    17,     4,     3,     3,   137,    18,    19,    20,    21,     3,
    23,    18,    19,    20,    21,     3,    23,   150,     3,     3,
     0,     0,    41,    25,    72,   146,    25,    72,   112,    -1,
    55,    29
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 144 "parser.y"
{ scene->addNodes(yyvsp[0].nodeList); ;
    break;}
case 3:
#line 148 "parser.y"
{ if (yyvsp[0].node != NULL) yyvsp[-1].nodeList->append(yyvsp[0].node); yyval.nodeList = yyvsp[-1].nodeList; ;
    break;}
case 4:
#line 149 "parser.y"
{ yyval.nodeList = new NodeList(); ;
    break;}
case 5:
#line 152 "parser.y"
{ yyval.node = yyvsp[0].node; ;
    break;}
case 6:
#line 153 "parser.y"
{ yyval.node = NULL; ;
    break;}
case 7:
#line 154 "parser.y"
{ yyval.node = NULL; ;
    break;}
case 8:
#line 157 "parser.y"
{ scene->updateURLs(yyvsp[0].node); ;
    break;}
case 9:
#line 158 "parser.y"
{ defName = yyvsp[0].id; ;
    break;}
case 10:
#line 158 "parser.y"
{ yyval.node = yyvsp[0].node; scene->updateURLs(yyvsp[0].node);;
    break;}
case 11:
#line 159 "parser.y"
{ yyval.node = scene->use(checkName(SYMB(yyvsp[0].id))); ;
    break;}
case 16:
#line 170 "parser.y"
{ 
                                 protoStack.push(new Proto(scene, SYMB(yyvsp[0].id)));
                                 if (!scene->addProtoName(SYMB(yyvsp[0].id)))
                                     {
                                     char buf[1024];
                                     mysnprintf(buf,1024,
                                                "proto already definied: %s",
                                                (const char*)SYMB(yyvsp[0].id));
                                     yyerror(buf);
                                     }
                                     
                                 ;
    break;}
case 17:
#line 183 "parser.y"
{ 
                                 scene->addProto(SYMB(yyvsp[-7].id),protoStack.pop()); 
                                 stopproto();
                                 ;
    break;}
case 18:
#line 190 "parser.y"
{ protoStack.peek()->define(yyvsp[-1].node, yyvsp[0].nodeList); ;
    break;}
case 20:
#line 195 "parser.y"
{
	      if (protoStack.empty()) yyerror("syntax error");
	      else protoStack.peek()->addElement(yyvsp[0].element);
	  ;
    break;}
case 22:
#line 202 "parser.y"
{ yyval.element = new EventIn(yyvsp[-1].int32, SYMB(yyvsp[0].id)); ;
    break;}
case 23:
#line 203 "parser.y"
{ yyval.element = new EventOut(yyvsp[-1].int32, SYMB(yyvsp[0].id)); ;
    break;}
case 24:
#line 204 "parser.y"
{ currentType = yyvsp[0].int32; ;
    break;}
case 25:
#line 205 "parser.y"
{ yyval.element = new Field(yyvsp[-3].int32, SYMB(yyvsp[-1].id), yyvsp[0].value); ;
    break;}
case 27:
#line 209 "parser.y"
{ currentType = yyvsp[0].int32; ;
    break;}
case 28:
#line 210 "parser.y"
{ yyval.element = new ExposedField(yyvsp[-3].int32, SYMB(yyvsp[-1].id), yyvsp[0].value); ;
    break;}
case 29:
#line 214 "parser.y"
{ 
                                protoStack.push(new Proto(scene, SYMB(yyvsp[0].id))); 
                                if (!scene->addProtoName(SYMB(yyvsp[0].id)))
                                    {
                                    char buf[1024];
                                    mysnprintf(buf,1024,
                                               "proto already definied: %s",
                                               (const char*)SYMB(yyvsp[0].id));
                                    yyerror(buf);
                                    }
                                     
                                 ;
    break;}
case 30:
#line 227 "parser.y"
{ 
                                scene->addProto(SYMB(yyvsp[-5].id), protoStack.pop()); 
                                stopproto();
                                ;
    break;}
case 31:
#line 234 "parser.y"
{
	      if (protoStack.empty()) yyerror("syntax error");
	      else protoStack.peek()->addElement(yyvsp[0].element);
	  ;
    break;}
case 33:
#line 241 "parser.y"
{ yyval.element = new EventIn(yyvsp[-1].int32, SYMB(yyvsp[0].id)); ;
    break;}
case 34:
#line 242 "parser.y"
{ yyval.element = new EventOut(yyvsp[-1].int32, SYMB(yyvsp[0].id)); ;
    break;}
case 35:
#line 243 "parser.y"
{ 
                                 yyval.element = new Field(yyvsp[-1].int32, SYMB(yyvsp[0].id),
                                            SillyDefaultValue(yyvsp[-1].int32));
                                 ;
    break;}
case 36:
#line 247 "parser.y"
{	                                        
                                     yyval.element = new ExposedField(yyvsp[-1].int32, SYMB(yyvsp[0].id),
                                                SillyDefaultValue(yyvsp[-1].int32));
                                     ;
    break;}
case 37:
#line 254 "parser.y"
{ 
             route(checkName(SYMB(yyvsp[-6].id)), SYMB(yyvsp[-4].id), 
                   checkName(SYMB(yyvsp[-2].id)), SYMB(yyvsp[0].id)); 
             ;
    break;}
case 40:
#line 265 "parser.y"
{ yyval.node = newNode(SYMB(yyvsp[-1].id)); nodeStack.push(yyval.node);
			      if (defName != -1) { 
				   scene->def(uniqName(SYMB(defName)), yyval.node);
				   defName = -1;
			      }
			    ;
    break;}
case 41:
#line 271 "parser.y"
{ yyval.node = nodeStack.pop(); ;
    break;}
case 42:
#line 272 "parser.y"
{ yyval.node = new NodeScript(scene); nodeStack.push(yyval.node);
			      if (defName != -1) { 
				   scene->def(uniqName(SYMB(defName)), yyval.node);
				   defName = -1;
			      }
			    ;
    break;}
case 43:
#line 278 "parser.y"
{ yyval.node = nodeStack.pop(); ((NodeScript *) yyval.node)->update(); ;
    break;}
case 46:
#line 286 "parser.y"
{
	      if (nodeStack.empty()) 
                  yyerror("syntax error");
	      else 
                  if (yyvsp[0].element) { 
                     nodeStack.peek()->getProto()->addElement(yyvsp[0].element);
                     nodeStack.peek()->update();
                     if (yyvsp[0].element->getElementType() == EL_FIELD_DEF) {
                         Field *field = (Field *)yyvsp[0].element;
                         // search for number of field to use setField 
                         Proto *proto =  nodeStack.peek()->getProto();
                         for (int i=0; i < proto->getNumFields(); i++)
                             if (proto->getField(i)->getName() 
                                 == field->getName())
                                 setField(nodeStack.peek(), i, 
                                          field->getDefault());
		  }
              }

	  ;
    break;}
case 48:
#line 309 "parser.y"
{ yyval.element = NULL; ;
    break;}
case 50:
#line 311 "parser.y"
{ if (protoStack.empty()) yyerror("IS statement used outside PROTO"); yyval.element = new EventIn(yyvsp[-3].int32, SYMB(yyvsp[-2].id)); ;
    break;}
case 51:
#line 312 "parser.y"
{ if (protoStack.empty()) yyerror("IS statement used outside PROTO"); yyval.element = new EventOut(yyvsp[-3].int32, SYMB(yyvsp[-2].id)); ;
    break;}
case 52:
#line 315 "parser.y"
{ setField(nodeStack.peek(),
						  yyvsp[-1].int32, yyvsp[0].value); ;
    break;}
case 53:
#line 317 "parser.y"
{ isField(nodeStack.peek(),
						   SYMB(yyvsp[-2].id), SYMB(yyvsp[0].id)); ;
    break;}
case 56:
#line 323 "parser.y"
{ yyval.int32 = checkField(nodeStack.peek(),
							  SYMB(yyvsp[0].id)); ;
    break;}
case 59:
#line 333 "parser.y"
{ yyval.int32 = typeStringToEnum(SYMB(yyvsp[0].id)); ;
    break;}
case 61:
#line 338 "parser.y"
{ yyval.value = stringToType(SYMB(yyvsp[0].id),currentType); ;
    break;}
case 62:
#line 339 "parser.y"
{ yyval.value = new MFString(yyvsp[-1].stringArray); ;
    break;}
case 63:
#line 340 "parser.y"
{ yyval.value = new SFNode(yyvsp[0].node); ;
    break;}
case 64:
#line 341 "parser.y"
{ yyval.value = emptyMFNodeOrNULL(currentType); ;
    break;}
case 65:
#line 342 "parser.y"
{ yyval.value = new MFNode(yyvsp[-1].nodeList); ;
    break;}
case 66:
#line 343 "parser.y"
{ yyval.value = intsToType(yyvsp[0].intArray, currentType); ;
    break;}
case 67:
#line 344 "parser.y"
{ yyval.value = floatsToType(yyvsp[0].floatArray, currentType); ;
    break;}
case 68:
#line 345 "parser.y"
{ yyval.value = intsToType(yyvsp[-1].intArray, currentType); ;
    break;}
case 69:
#line 346 "parser.y"
{ yyval.value = floatsToType(yyvsp[-1].floatArray, currentType); ;
    break;}
case 70:
#line 347 "parser.y"
{ yyval.value = emptyMF(currentType); ;
    break;}
case 71:
#line 348 "parser.y"
{ yyval.value = NULL; ;
    break;}
case 72:
#line 352 "parser.y"
{ yyval.value = new SFBool(true); ;
    break;}
case 73:
#line 353 "parser.y"
{ yyval.value = new SFBool(false); ;
    break;}
case 74:
#line 356 "parser.y"
{ yyvsp[-1].intArray->append(yyvsp[0].int32); yyval.intArray = yyvsp[-1].intArray; ;
    break;}
case 75:
#line 357 "parser.y"
{ yyval.intArray = new IntArray(); yyval.intArray->append(yyvsp[0].int32); ;
    break;}
case 76:
#line 360 "parser.y"
{ yyvsp[-1].floatArray->append(yyvsp[0].sffloat); yyval.floatArray = yyvsp[-1].floatArray; ;
    break;}
case 77:
#line 361 "parser.y"
{ yyvsp[-1].floatArray->append((float) yyvsp[0].int32); yyval.floatArray = yyvsp[-1].floatArray; ;
    break;}
case 78:
#line 362 "parser.y"
{ yyval.floatArray = intsToFloats(yyvsp[-1].intArray); yyval.floatArray->append(yyvsp[0].sffloat); delete yyvsp[-1].intArray; ;
    break;}
case 79:
#line 363 "parser.y"
{ yyval.floatArray = new FloatArray(); yyval.floatArray->append(yyvsp[0].sffloat); ;
    break;}
case 80:
#line 366 "parser.y"
{ yyval.value = new MFString(SYMB(yyvsp[0].id)); ;
    break;}
case 81:
#line 367 "parser.y"
{ yyval.value = new MFString(yyvsp[-1].stringArray); ;
    break;}
case 82:
#line 370 "parser.y"
{ yyval.stringArray = new StringArray();
	  			  yyval.stringArray->append(SYMB(yyvsp[0].id)); ;
    break;}
case 83:
#line 372 "parser.y"
{ yyvsp[-1].stringArray->append(SYMB(yyvsp[0].id)); yyval.stringArray = yyvsp[-1].stringArray; ;
    break;}
case 84:
#line 375 "parser.y"
{ yyval.nodeList = new NodeList();
					  if (yyvsp[0].node) yyval.nodeList->append(yyvsp[0].node); ;
    break;}
case 85:
#line 377 "parser.y"
{ if (yyvsp[0].node) yyvsp[-1].nodeList->append(yyvsp[0].node); yyval.nodeList = yyvsp[-1].nodeList; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 379 "parser.y"


int yywrap(void)
{
    return 1;
}

void yyerror(const char *s)
{
    scene->setErrorLineNumber(lineno);
#ifdef HAVE_LIBZ
    scene->errorf("%s in line %d\n", s, lineno);
#else
    if (strcmp(s,"parse error")==0)
        scene->errorf("%s (or unsupported compression (no gzip in this version)) in line %d\n",
                      s, lineno);
    else
        scene->errorf("%s in line %d\n", s, lineno);
#endif
}


static Node *
newNode(const MyString &nodeType)
{
    Proto	*proto = scene->getProto(nodeType);

    if (!proto) {
	scene->errorf("invalid node type %s in %d\n", 
                      (const char *) nodeType, lineno);
	return NULL;
    } else {
	return proto->create(scene);
    }
}

static FieldValue *
intsToType(IntArray *ints, int type)
{
    FieldValue *r = NULL;
    const int  *data = ints->getData();
    int		len = ints->size();

    switch(type) {
      case SFCOLOR:
	if (len != 3) {
	    yyerror("SFColor must have 3 values");
	} else {
	    r = new SFColor((float) data[0], (float) data[1], (float) data[2]);
	}
	break;
      case SFFLOAT:
	if (len != 1) {
	    yyerror("SFFloat must have 1 float value");
	} else {
	    r = new SFFloat((float) data[0]);
	}
	break;
      case SFIMAGE:
	if (len < 3) {
	    yyerror("SFImage must have at least 3 values");
	} else {
	    int width = data[0];
	    int height = data[1];
	    int depth = data[2];

	    if (len - 3 != width * height) {
		char	buf[1024];
		sprintf(buf, "SFImage data must have %d values\n", width * height);
		yyerror(buf);
	    } else {
		r = new SFImage(width, height, depth, data + 3);
	    }
	}
        break;
      case SFINT32:
	if (len != 1) {
	    yyerror("SFInt32 must have 1 integer value");
	} else {
	    r = new SFInt32(data[0]);
	}
	break;
      case SFROTATION:
	if (len != 4) {
	    yyerror("SFRotation must have 4 values");
	} else {
	    r = new SFRotation((float) data[0], (float) data[1], (float) data[2], (float) data[3]);
	}
	break;
      case SFTIME:
	if (len != 1) {
	    yyerror("SFTime must have 1 value");
	} else {
	    r = new SFTime((double) data[0]);
	}
	break;
      case SFVEC2F:
        if (len != 2) {
	    yyerror("SFVec2f must have 2 values");
	} else {
	    r = new SFVec2f((float) data[0], (float) data[1]);
	}
	break;
      case SFVEC3F:
        if (len != 3) {
	    yyerror("SFVec3f must have 3 values");
	} else {
	    r = new SFVec3f((float) data[0], (float) data[1], (float) data[2]);
	}
	break;
      case MFINT32:
	r = new MFInt32(ints->extractData(), len);
	break;
      case MFCOLOR:
      case MFFLOAT:
      case MFROTATION:
      case MFTIME:
      case MFVEC2F:
      case MFVEC3F:
	r = floatsToType(intsToFloats(ints), type);
	break;
      default:
        yyerror("type mismatch");
	break;
    }
    delete ints;
    return r;
}

static FieldValue *
floatsToType(FloatArray *floats, int type)
{
    FieldValue     *r = NULL;
    const float	   *data = floats->getData();
    int		    len = floats->size();

    switch(type) {
      case SFCOLOR:
	if (len != 3) {
	    yyerror("SFColor must have 3 values");
	} else {
	    r = new SFColor(data[0], data[1], data[2]);
	}
	break;
      case SFFLOAT:
	if (len != 1) {
	    yyerror("SFFloat must have 1 float value");
	} else {
	    r = new SFFloat(data[0]);
	}
	break;
      case SFROTATION:
	if (len != 4) {
	    yyerror("SFRotation must have 4 values");
	} else {
	    r = new SFRotation(data[0], data[1], data[2], data[3]);
	}
	break;
      case SFTIME:
	if (len != 1) {
	    yyerror("SFTime must have 1 value");
	} else {
	    r = new SFTime((double) data[0]);
	}
	break;
      case SFVEC2F:
        if (len != 2) {
	    yyerror("SFVec2f must have 2 values");
	} else {
	    r = new SFVec2f(data[0], data[1]);
	}
	break;
      case SFVEC3F:
        if (len != 3) {
	    yyerror("SFVec3f must have 3 values");
	} else {
	    r = new SFVec3f(data[0], data[1], data[2]);
	}
	break;
      case MFCOLOR:
	if (len % 3 != 0) {
	    yyerror("MFColor must be a multiple of 3 values");
	} else {
	    r = new MFColor(floats->extractData(), len);
	}
	break;
      case MFFLOAT:
	r = new MFFloat(floats->extractData(), len);
	break;
      case MFROTATION:
	if (len % 4 != 0) {
	    yyerror("MFRotation must be a multiple of 4 values");
	} else {
	    r = new MFRotation(floats->extractData(), len);
	}
	break;
      case MFTIME:
        r = new MFTime(data, len);
	break;
      case MFVEC2F:
	if (len % 2 != 0) {
	    yyerror("MFVec2f must be a multiple of 2 values");
	} else {
	    r = new MFVec2f(floats->extractData(), len);
	}
	break;
      case MFVEC3F:
	if (len % 3 != 0) {
	    yyerror("MFVec3f must be a multiple of 2 values");
	} else {
	    r = new MFVec3f(floats->extractData(), len);
	}
	break;
      default:
        yyerror("type mismatch");
	break;
    }
    delete floats;
    return r;
}

static FieldValue *
stringToType(const char *string, int type)
{
    FieldValue     *r = NULL;

    switch(type) {
      case SFSTRING:
        r=new SFString(string);
	break;
      case MFSTRING:
        r=new MFString(string);
	break;
      default:
        yyerror("type mismatch");
	break;
    }
    return r;
}

static FieldValue *
emptyMFNodeOrNULL(int type)
{
    if (type==SFNODE)
       return new SFNode(NULL);
    else if (type==MFNODE)
       return emptyMF(type);
    else {
       /* NULL only allowed for Node types
          see VRML97 Grammar 
          http://www.web3d.org/technicalinfo/specifications/vrml97/part1/grammar.html#Fields
          sfnodeValue ::= 
              nodeStatement | 
              NULL ; 
       
       */
       fprintf(stderr,"NULL only allowed for Node types, assuming \"[]\" in line %d\n",lineno);
       return emptyMF(type);
    }
}

static FieldValue *
emptyMF(int type)
{
    switch(type) {
      case MFCOLOR:
	return new MFColor();
      case MFFLOAT:
        return new MFFloat();
      case MFINT32:
	return new MFInt32();
      case MFNODE:
        return new MFNode();
      case MFROTATION:
        return new MFRotation();
      case MFSTRING:
        return new MFString();
      case MFTIME:
        return new MFTime();
      case MFVEC2F:
	return new MFVec2f();
      case MFVEC3F:
        return new MFVec3f();
      default:
        yyerror("type mismatch");
	return NULL;
    }
}

/*
 * Currently, EXTERNPROTO Definitions are not read
 * field need a senseful default value
 */

static FieldValue *
SillyDefaultValue(int type)
{
    fprintf(stderr,"BUG: Currently, EXTERNPROTO definitions are not read\n");
    fprintf(stderr,"BUG: Default field values of this Proto are incorrect\n");

    if (FieldValue *value=typeDefaultValue(type))
       return value;
    else {
       yyerror("intern error: type no supported");
       return NULL;
    }
}

//
// checkField() - verify a field reference
//
// check that the node "node" has the field "fieldName"
// if not, print an error
// if so, stash its type in the lexer, and return its index

static int
checkField(Node *node, const MyString &fieldName)
{
    if (!node) return INVALID_INDEX;

    Proto	*proto = node->getProto();

    if (!proto) return INVALID_INDEX;

    int index = proto->lookupField(fieldName);

    if (index == INVALID_INDEX) {
        scene->invalidField(proto->getName(), fieldName);
    } else {
	currentType = proto->getField(index)->getType();
    }

    return index;
}


static void
setField(Node *node, int index, FieldValue *value)
{
    FieldValue	*newValue;

    if (!node || !value || index < 0) return;

    Proto	*proto = node->getProto();

    if (!proto) return;

    Field    *field = proto->getField(index);

    if (value->getType() == SFSTRING && field->getType() == MFSTRING) {
        newValue = new MFString(((SFString *) value)->getValue());
	delete value;
	value = newValue;
    } else if (value->getType() == SFNODE && field->getType() == MFNODE) {
	NodeList	*list = new NodeList();
	list->append(((SFNode *) value)->getValue());
	newValue = new MFNode(list);
	delete value;
	value = newValue;
    }

    if (value->getType() != field->getType()) {
        scene->errorf("type mismatch:  field \"%s\"\n", (const char *)
							field->getName());
	delete value;
    } else {
	node->setField(index, value);
    }
}

static void
isField(Node *node, const MyString &fieldName, const MyString &isName)
{
    int srcField, srcEventIn, srcEventOut, srcExposedField;
    int dstField, dstEventIn, dstEventOut, dstExposedField;

    if (!node) return;

    Proto	*source = node->getProto();

    if (!source) return;

    if (protoStack.empty()) {
	scene->errorf("IS statement used outside PROTO");
	return;
    }

    Proto	*proto = protoStack.peek();

    if ((srcExposedField = source->lookupExposedField(fieldName)) != -1) {
	dstEventIn = proto->lookupEventIn(isName);
	dstEventOut = proto->lookupEventOut(isName);

	if ((dstField = proto->lookupField(isName)) != -1) {
	    // FIXME:  do something useful
	} else if ((dstEventIn = proto->lookupEventIn(isName)) != -1) {
	    // FIXME:  do something useful
	} else if ((dstEventOut = proto->lookupEventOut(isName)) != -1) {
	    // FIXME:  do something useful
	} else if ((dstExposedField = proto->lookupExposedField(isName)) != -1) {
	    // FIXME:  do something useful
	} else {
	    scene->invalidField(source->getName(), isName);
	}
    } else if ((srcField = source->lookupField(fieldName)) != -1) {
	dstField = proto->lookupField(isName);
	if (dstField != -1) {
	    // FIXME:  do something useful
	} else {
	    scene->invalidField(source->getName(), isName);
	}
    } else if ((srcEventIn = source->lookupEventIn(fieldName)) != -1) {
	dstEventIn = proto->lookupEventIn(isName);
	if (dstEventIn != -1) {
	    // FIXME:  do something useful
	} else {
	    scene->invalidField(source->getName(), isName);
	}
    } else if ((srcEventOut = source->lookupEventOut(fieldName)) != -1) {
	dstEventOut = proto->lookupEventOut(isName);
	if (dstEventOut != -1) {
	    // FIXME:  do something useful
	} else {
	    scene->invalidField(source->getName(), isName);
	}
    }
}

static void
route(const MyString &srcNode, const MyString &srcField,
      const MyString &dstNode, const MyString &dstField)
{
    int		eventIn;
    int		eventOut;
    bool	valid = true;

    Node       *src = scene->use(srcNode);
    if (!src) {
	scene->invalidNode(srcNode);
	valid = false;
    } else {
	eventOut = src->lookupEventOut(srcField);
	if (eventOut == INVALID_INDEX) {
	    scene->errorf("node \"%s\" has no eventOut \"%s\"",
			  (const char *) srcNode, (const char *) srcField);
	    valid = false;
	}
    }

    Node       *dst = scene->use(dstNode);
    if (!dst) {
	scene->invalidNode(dstNode);
	valid = false;
    } else {
	eventIn = dst->lookupEventIn(dstField);
	if (eventIn == INVALID_INDEX) {
	    scene->errorf("node \"%s\" has no eventIn \"%s\"",
			  (const char *) dstNode, (const char *) dstField);
	    valid = false;
	}
    }

    if (valid) {
	src->update();
	dst->update();
	scene->addRoute(src, eventOut, dst, eventIn);
    }
}

static FloatArray *
intsToFloats(IntArray *ints)
{
    if (ints == NULL ) return NULL;

    int		     len = ints->size();
    FloatArray	    *r = new FloatArray(len);
    const int	    *d = ints->getData();
    for (int i = 0; i < len; i++) {
	r->set(i, (float) d[i]);
    }
    return r;
}

/* avoid double DEFs while file import */

static MyString
uniqName(const MyString name)
{
    int i=0;
    if (scene->hasAlreadyName(name)) {
        while (true) {
            char* buf=(char*) malloc(strlen((const char*) name)+512);
            sprintf(buf, "%s_%d", (const char*) name, i++);
            MyString* newName=new MyString(buf);
            free(buf);
            if (!scene->hasAlreadyName(*newName)) {
                NameTranslation.append(new nameTranslation(*newName,name));
                return *newName;
            }
        }
    }
    return name;
}

/* replace double DEFs while file import */

static MyString
checkName(const MyString name)
{
    for (int i=NameTranslation.size()-1;i>=0;i--)
        if (name==NameTranslation[i]->oldName) {
            return NameTranslation[i]->newName;
        }
    return name;
}



